#!/usr/bin/perl
# ircmap_convert.pl v0.94
#
# Copyright (C) 2001 Steven Van Acker
# Copyright 2002 Julien Wajsberg <flash@rezosup.net>
#
# This file is part of IRCmap4rz.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# February 2002 : 
# 	- changed from http://deepstar.ekonomika.be/Projects/Small/IRCmap/
#	for RezoSup by Flash <flash@rezosup.net>
#
# May 25 2002 : 0.93b
#	- Added support for irc6 type servers (Flash <flash@rezosup.net>
#
# March 2 2003 : 0.94
# 	- Added support for irc# type servers (Flash <flash@rezosup.net>

print "graph: {\n";
print "\n";
print "layoutalgorithm: forcedir\n";
print "\n";
print "colorentry 1: 255 255 255\n"; # blanc
print "colorentry 2: 000 079 164\n"; # serveur normal bordure
print "colorentry 3: 000 128 164\n"; # serveur normal fond
print "colorentry 4: 198 226 255\n"; # fond du graphe
print "colorentry 5: 000 080 100\n"; # hub fond
print "colorentry 6: 000 000 000\n"; # hub bordure
#print "colorentry 7: 255 255 000\n"; # jaune
print "colorentry 7: 130 023 023\n"; # bordeaux
print "colorentry 8: 000 164 192\n"; # irc6
print "color: 4\n";
print "node.fontname: \"helvR12.vcf\"\n";
#print "scaling: maxaspect";
print "\n";
print "port_sharing: no\n";
print "arrowmode: free\n";
print "\n";
#print "orientation: lefttoright\n";
print "\n";
print "node.textcolor: 1\n";
print "node.color: 3\n";
print "node.borderwidth: 1\n";
print "node.bordercolor: 2\n";
print "\n";
print "edge.color: 3\n";
print "edge.arrowstyle: none\n";

print "\nattraction: 140\n";
print "repulsion: 100\n";
print "magnetic_field1: polar\n";
print "magnetic_field2: no\n";

print "\ngravity: 0.0\n";

@links = ();

while($zin = <STDIN>)
{
	chomp($zin);
	#$_ = $zin;
	$zin =~ s/\r//g;

	if($zin and ($zin !~ /^\s*$/))
	{
		@parts = split(/ /, $zin);
		if(scalar @parts < 5)
		{
			next;
		}
		@links[$i] = @parts[3];
		@links[$i+1] = @parts[4];
		
		$i += 2;
	}
}

@hosts = ();
LINK: foreach $link (@links)
{
	foreach $host (@hosts)
	{
		if($link eq $host)
		{
			next LINK;
		}
	}
	push(@hosts,$link);
}

foreach $host (@hosts)
{
	($debut, $tld) = ( $host =~ /^(.*)\.rezosup\.(net|org)$/i );
	if ($debut =~ /^[^\.]*$/ ) { # pas de point
		$ecole = $debut;
		$type = "interne";
	} else {
		($type, $ecole) = ( $debut =~ /^(irc\d?|hub|intra|test)\.([a-z0-9_-]*)$/i );
	}

SWITCH: for ($type) {
			/test/		&& do { $color = 7 ; $textcolor = 1 ; $bordercolor = 6; last; } ;
			/interne/	&& do { $color = 7 ; $textcolor = 1 ; $bordercolor = 6; last; } ;
			/intra/		&& do { $color = 3 ; $textcolor = 1 ; $bordercolor = 2; last; } ;
			/irc6/		&& do { $color = 8 ; $textcolor = 1 ; $bordercolor = 2; last; } ;
			/irc/		&& do { $color = 3 ; $textcolor = 1 ; $bordercolor = 2; last; } ;
			/hub/		&& do { $color = 5 ; $textcolor = 1 ; $bordercolor = 6; last; } ;
			die "Erreur : type invalide : $_\nligne  : $host";
		}
	if ($type !~ '/test/')
       	{		
		print "node: { title: \"$host\" label: \"$ecole\" color: $color bordercolor: $bordercolor textcolor: $textcolor }\n";
	}
}

$flag = 0;
foreach $link (@links)
{
	if($flag == 0)
	{
		print "edge: { sourcename: \"$link\" ";
		$flag = 1;
	}
	else
	{
		print "targetname: \"$link\" }\n";
		$flag = 0;
	}
}

print "}\n";


